
/* copyright (c) 2000 
   the regents of the university of michigan 
   all rights reserved 
   
   permission is granted to use, copy, create derivative works and  
   redistribute this software and such derivative works for any purpose,  
   so long as the name of the university of michigan is not used in any  
   advertising or publicity pertaining to the use or distribution of this  
   software without specific, written prior authorization.  if the above  
   copyright notice or any other identification of the university of  
   michigan is included in any copy of any portion of this software, then  
   the disclaimer below must also be included. 
   
   this software is provided as is, without representation from the  
   university of michigan as to its fitness for any purpose, and without  
   warranty by the university of michigan of any kind, either express or  
   implied, including without limitation the implied warranties of  
   merchantability and fitness for a particular purpose.  the regents of  
   the university of michigan shall not be liable for any damages,  
   including special, indirect, incidental, or consequential damages, with  
   respect to any claim arising out or in connection with the use of the  
   software, even if it has been or is hereafter advised of the  
   possibility of such damages. */

/* Generated from pts.xg */
#include "pts.h"

#include "pts.cs.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <roken.h>
#include <arlad/fs_errors.h>
#ifndef HAVE_BCOPY
#define bcopy(a,b,c) memcpy((b),(a),(c))
#endif /* !HAVE_BCOPY */

#ifdef RCSID
RCSID("pts.cs.c generated from pts.xg with $Id: output.c,v 1.43 1998/12/13 16:52:04 assar Exp $");
#endif

int PR_NameToID(
struct rx_connection *connection
, const namelist *nlist
, idlist *ilist
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (504);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl ((*nlist).len);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{
int i0;
for(i0 = 0; i0 < (*nlist).len;++i0){
{
int i1;
for(i1 = 0; i1 < 64;++i1){
{ u_int32_t u;
u = htonl ((*nlist).val[i0][i1]);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
}
}
}
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*ilist).len = ntohl (u);
}
(*ilist).val = (int32_t *)malloc(sizeof(int32_t ) * (*ilist).len);
{
int i0;
for(i0 = 0; i0 < (*ilist).len;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*ilist).val[i0] = ntohl (u);
}
}
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_IDToName(
struct rx_connection *connection
, const idlist *ilist
, namelist *nlist
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (505);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl ((*ilist).len);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{
int i0;
for(i0 = 0; i0 < (*ilist).len;++i0){
{ u_int32_t u;
u = htonl ((*ilist).val[i0]);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
}
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*nlist).len = ntohl (u);
}
(*nlist).val = (prname *)malloc(sizeof(prname ) * (*nlist).len);
{
int i0;
for(i0 = 0; i0 < (*nlist).len;++i0){
{
int i1;
for(i1 = 0; i1 < 64;++i1){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*nlist).val[i0][i1] = ntohl (u);
}
}
}
}
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_NewEntry(
struct rx_connection *connection
, const char name[64]
, const int32_t flag
, const int32_t oid
, int32_t *id
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (509);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ unsigned len;
char zero[4] = {0, 0, 0, 0};
unsigned padlen;
len = strlen(name);
padlen = (4 - (len % 4)) % 4;
{ u_int32_t u;
u = htonl (len);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
if(rx_Write(call, name, len) != len)
goto fail;
if(rx_Write(call, zero, padlen) != padlen)
goto fail;
}
{ u_int32_t u;
u = htonl (flag);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (oid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*id) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_INewEntry(
struct rx_connection *connection
, const char name[ 64 ]
, const int32_t id
, const int32_t oid
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (500);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{
int i0;
for(i0 = 0; i0 < 64;++i0){
{ u_int32_t u;
u = htonl (name[i0]);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
}
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (oid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_ListEntry(
struct rx_connection *connection
, const int32_t id
, struct prcheckentry *entry
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (512);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).flags = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).id = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).owner = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).creator = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).ngroups = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).nusers = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).count = ntohl (u);
}
{
int i0;
for(i0 = 0; i0 < 5;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).reserved[i0] = ntohl (u);
}
}
}
{
int i0;
for(i0 = 0; i0 < 64;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).name[i0] = ntohl (u);
}
}
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_DumpEntry(
struct rx_connection *connection
, const int32_t pos
, struct prdebugentry *entry
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (502);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (pos);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).flags = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).id = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).cellid = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).next = ntohl (u);
}
{
int i0;
for(i0 = 0; i0 < 5;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).reserved[i0] = ntohl (u);
}
}
}
{
int i0;
for(i0 = 0; i0 < 10;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).entries[i0] = ntohl (u);
}
}
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).nextID = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).nextname = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).owner = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).creator = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).ngroups = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).nusers = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).count = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).instance = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).owned = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).nextOwned = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).parent = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).sibling = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).child = ntohl (u);
}
{
int i0;
for(i0 = 0; i0 < 64;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*entry).name[i0] = ntohl (u);
}
}
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_ChangeEntry(
struct rx_connection *connection
, const int32_t id
, const char name[64]
, const int32_t oid
, const int32_t newid
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (513);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ unsigned len;
char zero[4] = {0, 0, 0, 0};
unsigned padlen;
len = strlen(name);
padlen = (4 - (len % 4)) % 4;
{ u_int32_t u;
u = htonl (len);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
if(rx_Write(call, name, len) != len)
goto fail;
if(rx_Write(call, zero, padlen) != padlen)
goto fail;
}
{ u_int32_t u;
u = htonl (oid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (newid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_SetFieldsEntry(
struct rx_connection *connection
, const int32_t id
, const int32_t mask
, const int32_t flags
, const int32_t ngroups
, const int32_t nusers
, const int32_t spare1
, const int32_t spare2
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (516);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (mask);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (flags);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (ngroups);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (nusers);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (spare1);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (spare2);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_Delete(
struct rx_connection *connection
, const int32_t id
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (506);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_WhereIsIt(
struct rx_connection *connection
, const int32_t id
, int32_t *ps
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (501);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*ps) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_AddToGroup(
struct rx_connection *connection
, const int32_t uid
, const int32_t gid
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (503);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (uid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (gid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_RemoveFromGroup(
struct rx_connection *connection
, const int32_t id
, const int32_t gid
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (507);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (gid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_ListMax(
struct rx_connection *connection
, int32_t *uid
, int32_t *gid
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (510);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*uid) = ntohl (u);
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*gid) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_SetMax(
struct rx_connection *connection
, const int32_t uid
, const int32_t gflag
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (511);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (uid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (gflag);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_ListElements(
struct rx_connection *connection
, const int32_t id
, prlist *elist
, int32_t *over
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (514);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*elist).len = ntohl (u);
}
(*elist).val = (int32_t *)malloc(sizeof(int32_t ) * (*elist).len);
{
int i0;
for(i0 = 0; i0 < (*elist).len;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*elist).val[i0] = ntohl (u);
}
}
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*over) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_GetCPS(
struct rx_connection *connection
, const int32_t id
, prlist *elist
, int32_t *over
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (508);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*elist).len = ntohl (u);
}
(*elist).val = (int32_t *)malloc(sizeof(int32_t ) * (*elist).len);
{
int i0;
for(i0 = 0; i0 < (*elist).len;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*elist).val[i0] = ntohl (u);
}
}
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*over) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_ListOwned(
struct rx_connection *connection
, const int32_t id
, prlist *elist
, int32_t *over
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (517);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (id);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*elist).len = ntohl (u);
}
(*elist).val = (int32_t *)malloc(sizeof(int32_t ) * (*elist).len);
{
int i0;
for(i0 = 0; i0 < (*elist).len;++i0){
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*elist).val[i0] = ntohl (u);
}
}
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*over) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
int PR_IsAMemberOf(
struct rx_connection *connection
, const int32_t uid
, const int32_t gid
, int32_t *flag
)
{
struct rx_call *call;
int ret = 0;
call = rx_NewCall (connection);
{ u_int32_t u;
u = htonl (515);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (uid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
u = htonl (gid);
if(rx_Write(call, &u, sizeof(u)) != sizeof(u))
goto fail;
}
{ u_int32_t u;
if(rx_Read(call, &u, sizeof(u)) != sizeof(u))
goto fail;
(*flag) = ntohl (u);
}
return rx_EndCall (call,0);
fail:
ret = conv_to_arla_errno(rx_Error(call));
rx_EndCall (call, 0);
return ret;
}
